require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FENV_H_)) {
    eval 'sub _FENV_H_ () {1;}' unless defined(&_FENV_H_);
    require 'sys/_types.ph';
    unless(defined(&__fenv_static)) {
	eval 'sub __fenv_static () { &static;}' unless defined(&__fenv_static);
    }
    eval 'sub FE_INVALID () {0x1;}' unless defined(&FE_INVALID);
    eval 'sub FE_DIVBYZERO () {0x2;}' unless defined(&FE_DIVBYZERO);
    eval 'sub FE_OVERFLOW () {0x4;}' unless defined(&FE_OVERFLOW);
    eval 'sub FE_UNDERFLOW () {0x8;}' unless defined(&FE_UNDERFLOW);
    eval 'sub FE_INEXACT () {0x10;}' unless defined(&FE_INEXACT);
    eval 'sub FE_ALL_EXCEPT () {( &FE_DIVBYZERO |  &FE_INEXACT |  &FE_INVALID |  &FE_OVERFLOW |  &FE_UNDERFLOW);}' unless defined(&FE_ALL_EXCEPT);
    eval 'sub FE_TONEAREST () {0x;}' unless defined(&FE_TONEAREST);
    eval 'sub FE_UPWARD () {0x1;}' unless defined(&FE_UPWARD);
    eval 'sub FE_DOWNWARD () {0x2;}' unless defined(&FE_DOWNWARD);
    eval 'sub FE_TOWARDZERO () {0x3;}' unless defined(&FE_TOWARDZERO);
    eval 'sub _ROUND_MASK () {( &FE_TONEAREST |  &FE_DOWNWARD |  &FE_UPWARD |  &FE_TOWARDZERO);}' unless defined(&_ROUND_MASK);
    eval 'sub _ROUND_SHIFT () {22;}' unless defined(&_ROUND_SHIFT);
    eval 'sub FE_DFL_ENV () {(& &__fe_dfl_env);}' unless defined(&FE_DFL_ENV);
    eval 'sub _FPUSW_SHIFT () {8;}' unless defined(&_FPUSW_SHIFT);
    eval 'sub _ENABLE_MASK () {( &FE_ALL_EXCEPT <<  &_FPUSW_SHIFT);}' unless defined(&_ENABLE_MASK);
    eval 'sub __mrs_fpcr {
        my($__r) = @_;
	    eval q( &__asm  &__volatile(\\"mrs %0, fpcr\\" : \\"=r\\" ($__r)));
    }' unless defined(&__mrs_fpcr);
    eval 'sub __msr_fpcr {
        my($__r) = @_;
	    eval q( &__asm  &__volatile(\\"msr fpcr, %0\\" : : \\"r\\" ($__r)));
    }' unless defined(&__msr_fpcr);
    eval 'sub __mrs_fpsr {
        my($__r) = @_;
	    eval q( &__asm  &__volatile(\\"mrs %0, fpsr\\" : \\"=r\\" ($__r)));
    }' unless defined(&__mrs_fpsr);
    eval 'sub __msr_fpsr {
        my($__r) = @_;
	    eval q( &__asm  &__volatile(\\"msr fpsr, %0\\" : : \\"r\\" ($__r)));
    }' unless defined(&__msr_fpsr);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub fedisableexcept {
	    my($__mask) = @_;
    	    eval q({  &fenv_t  &__old_r,  &__new_r;  &__mrs_fpcr( &__old_r);  &__new_r =  &__old_r & ~(($__mask &  &FE_ALL_EXCEPT) <<  &_FPUSW_SHIFT);  &__msr_fpcr( &__new_r); (( &__old_r >>  &_FPUSW_SHIFT) &  &FE_ALL_EXCEPT); });
	}' unless defined(&fedisableexcept);
	eval 'sub fegetexcept {
	    my($void) = @_;
    	    eval q({  &fenv_t  &__r;  &__mrs_fpcr( &__r); (( &__r &  &_ENABLE_MASK) >>  &_FPUSW_SHIFT); });
	}' unless defined(&fegetexcept);
    }
}
1;
