require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ARMREG_H_)) {
    eval 'sub _MACHINE_ARMREG_H_ () {1;}' unless defined(&_MACHINE_ARMREG_H_);
    eval 'sub INSN_SIZE () {4;}' unless defined(&INSN_SIZE);
    eval 'sub READ_SPECIALREG {
        my($reg) = @_;
	    eval q(({  &uint64_t  &val;  &__asm  &__volatile(\\"mrs	%0, \\"  &__STRING($reg) : \\"=&r\\" ( &val));  &val; }));
    }' unless defined(&READ_SPECIALREG);
    eval 'sub WRITE_SPECIALREG {
        my($reg, $val) = @_;
	    eval q( &__asm  &__volatile(\\"msr	\\"  &__STRING($reg) \\", %0\\" : : \\"r\\"(( &uint64_t)$val)));
    }' unless defined(&WRITE_SPECIALREG);
    eval 'sub UL {
        my($x) = @_;
	    eval q( &UINT64_C($x));
    }' unless defined(&UL);
    eval 'sub CNTHCTL_EVNTI_MASK () {(0xf << 4);}' unless defined(&CNTHCTL_EVNTI_MASK);
    eval 'sub CNTHCTL_EVNTDIR () {(1<< 3);}' unless defined(&CNTHCTL_EVNTDIR);
    eval 'sub CNTHCTL_EVNTEN () {(1<< 2);}' unless defined(&CNTHCTL_EVNTEN);
    eval 'sub CNTHCTL_EL1PCEN () {(1<< 1);}' unless defined(&CNTHCTL_EL1PCEN);
    eval 'sub CNTHCTL_EL1PCTEN () {(1<< 0);}' unless defined(&CNTHCTL_EL1PCTEN);
    eval 'sub CPACR_FPEN_MASK () {(0x3 << 20);}' unless defined(&CPACR_FPEN_MASK);
    eval 'sub CPACR_FPEN_TRAP_ALL1 () {(0x << 20);}' unless defined(&CPACR_FPEN_TRAP_ALL1);
    eval 'sub CPACR_FPEN_TRAP_EL0 () {(0x1 << 20);}' unless defined(&CPACR_FPEN_TRAP_EL0);
    eval 'sub CPACR_FPEN_TRAP_ALL2 () {(0x2 << 20);}' unless defined(&CPACR_FPEN_TRAP_ALL2);
    eval 'sub CPACR_FPEN_TRAP_NONE () {(0x3 << 20);}' unless defined(&CPACR_FPEN_TRAP_NONE);
    eval 'sub CPACR_TTA () {(0x1 << 28);}' unless defined(&CPACR_TTA);
    eval 'sub CTR_DLINE_SHIFT () {16;}' unless defined(&CTR_DLINE_SHIFT);
    eval 'sub CTR_DLINE_MASK () {(0xf <<  &CTR_DLINE_SHIFT);}' unless defined(&CTR_DLINE_MASK);
    eval 'sub CTR_DLINE_SIZE {
        my($reg) = @_;
	    eval q(((($reg) &  &CTR_DLINE_MASK) >>  &CTR_DLINE_SHIFT));
    }' unless defined(&CTR_DLINE_SIZE);
    eval 'sub CTR_ILINE_SHIFT () {0;}' unless defined(&CTR_ILINE_SHIFT);
    eval 'sub CTR_ILINE_MASK () {(0xf <<  &CTR_ILINE_SHIFT);}' unless defined(&CTR_ILINE_MASK);
    eval 'sub CTR_ILINE_SIZE {
        my($reg) = @_;
	    eval q(((($reg) &  &CTR_ILINE_MASK) >>  &CTR_ILINE_SHIFT));
    }' unless defined(&CTR_ILINE_SIZE);
    eval 'sub DAIF_D_MASKED () {(1<< 9);}' unless defined(&DAIF_D_MASKED);
    eval 'sub DAIF_A_MASKED () {(1<< 8);}' unless defined(&DAIF_A_MASKED);
    eval 'sub DAIF_I_MASKED () {(1<< 7);}' unless defined(&DAIF_I_MASKED);
    eval 'sub DAIF_F_MASKED () {(1<< 6);}' unless defined(&DAIF_F_MASKED);
    eval 'sub DCZID_DZP () {(1<< 4);}' unless defined(&DCZID_DZP);
    eval 'sub DCZID_BS_SHIFT () {0;}' unless defined(&DCZID_BS_SHIFT);
    eval 'sub DCZID_BS_MASK () {(0xf <<  &DCZID_BS_SHIFT);}' unless defined(&DCZID_BS_MASK);
    eval 'sub DCZID_BS_SIZE {
        my($reg) = @_;
	    eval q(((($reg) &  &DCZID_BS_MASK) >>  &DCZID_BS_SHIFT));
    }' unless defined(&DCZID_BS_SIZE);
    eval 'sub ESR_ELx_ISS_MASK () {0xffffff;}' unless defined(&ESR_ELx_ISS_MASK);
    eval 'sub ISS_INSN_FnV () {(0x1 << 10);}' unless defined(&ISS_INSN_FnV);
    eval 'sub ISS_INSN_EA () {(0x1 << 9);}' unless defined(&ISS_INSN_EA);
    eval 'sub ISS_INSN_S1PTW () {(0x1 << 7);}' unless defined(&ISS_INSN_S1PTW);
    eval 'sub ISS_INSN_IFSC_MASK () {(0x1f << 0);}' unless defined(&ISS_INSN_IFSC_MASK);
    eval 'sub ISS_DATA_ISV () {(0x1 << 24);}' unless defined(&ISS_DATA_ISV);
    eval 'sub ISS_DATA_SAS_MASK () {(0x3 << 22);}' unless defined(&ISS_DATA_SAS_MASK);
    eval 'sub ISS_DATA_SSE () {(0x1 << 21);}' unless defined(&ISS_DATA_SSE);
    eval 'sub ISS_DATA_SRT_MASK () {(0x1f << 16);}' unless defined(&ISS_DATA_SRT_MASK);
    eval 'sub ISS_DATA_SF () {(0x1 << 15);}' unless defined(&ISS_DATA_SF);
    eval 'sub ISS_DATA_AR () {(0x1 << 14);}' unless defined(&ISS_DATA_AR);
    eval 'sub ISS_DATA_FnV () {(0x1 << 10);}' unless defined(&ISS_DATA_FnV);
    eval 'sub ISS_DATA_EA () {(0x1 << 9);}' unless defined(&ISS_DATA_EA);
    eval 'sub ISS_DATA_CM () {(0x1 << 8);}' unless defined(&ISS_DATA_CM);
    eval 'sub ISS_DATA_S1PTW () {(0x1 << 7);}' unless defined(&ISS_DATA_S1PTW);
    eval 'sub ISS_DATA_WnR () {(0x1 << 6);}' unless defined(&ISS_DATA_WnR);
    eval 'sub ISS_DATA_DFSC_MASK () {(0x3f << 0);}' unless defined(&ISS_DATA_DFSC_MASK);
    eval 'sub ISS_DATA_DFSC_ASF_L0 () {(0x << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L0);
    eval 'sub ISS_DATA_DFSC_ASF_L1 () {(0x1 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L1);
    eval 'sub ISS_DATA_DFSC_ASF_L2 () {(0x2 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L2);
    eval 'sub ISS_DATA_DFSC_ASF_L3 () {(0x3 << 0);}' unless defined(&ISS_DATA_DFSC_ASF_L3);
    eval 'sub ISS_DATA_DFSC_TF_L0 () {(0x4 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L0);
    eval 'sub ISS_DATA_DFSC_TF_L1 () {(0x5 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L1);
    eval 'sub ISS_DATA_DFSC_TF_L2 () {(0x6 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L2);
    eval 'sub ISS_DATA_DFSC_TF_L3 () {(0x7 << 0);}' unless defined(&ISS_DATA_DFSC_TF_L3);
    eval 'sub ISS_DATA_DFSC_AFF_L1 () {(0x9 << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L1);
    eval 'sub ISS_DATA_DFSC_AFF_L2 () {(0xa << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L2);
    eval 'sub ISS_DATA_DFSC_AFF_L3 () {(0xb << 0);}' unless defined(&ISS_DATA_DFSC_AFF_L3);
    eval 'sub ISS_DATA_DFSC_PF_L1 () {(0xd << 0);}' unless defined(&ISS_DATA_DFSC_PF_L1);
    eval 'sub ISS_DATA_DFSC_PF_L2 () {(0xe << 0);}' unless defined(&ISS_DATA_DFSC_PF_L2);
    eval 'sub ISS_DATA_DFSC_PF_L3 () {(0xf << 0);}' unless defined(&ISS_DATA_DFSC_PF_L3);
    eval 'sub ISS_DATA_DFSC_EXT () {(0x10 << 0);}' unless defined(&ISS_DATA_DFSC_EXT);
    eval 'sub ISS_DATA_DFSC_EXT_L0 () {(0x14 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L0);
    eval 'sub ISS_DATA_DFSC_EXT_L1 () {(0x15 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L1);
    eval 'sub ISS_DATA_DFSC_EXT_L2 () {(0x16 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L2);
    eval 'sub ISS_DATA_DFSC_EXT_L3 () {(0x17 << 0);}' unless defined(&ISS_DATA_DFSC_EXT_L3);
    eval 'sub ISS_DATA_DFSC_ECC () {(0x18 << 0);}' unless defined(&ISS_DATA_DFSC_ECC);
    eval 'sub ISS_DATA_DFSC_ECC_L0 () {(0x1c << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L0);
    eval 'sub ISS_DATA_DFSC_ECC_L1 () {(0x1d << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L1);
    eval 'sub ISS_DATA_DFSC_ECC_L2 () {(0x1e << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L2);
    eval 'sub ISS_DATA_DFSC_ECC_L3 () {(0x1f << 0);}' unless defined(&ISS_DATA_DFSC_ECC_L3);
    eval 'sub ISS_DATA_DFSC_ALIGN () {(0x21 << 0);}' unless defined(&ISS_DATA_DFSC_ALIGN);
    eval 'sub ISS_DATA_DFSC_TLB_CONFLICT () {(0x30 << 0);}' unless defined(&ISS_DATA_DFSC_TLB_CONFLICT);
    eval 'sub ESR_ELx_IL () {(0x1 << 25);}' unless defined(&ESR_ELx_IL);
    eval 'sub ESR_ELx_EC_SHIFT () {26;}' unless defined(&ESR_ELx_EC_SHIFT);
    eval 'sub ESR_ELx_EC_MASK () {(0x3f << 26);}' unless defined(&ESR_ELx_EC_MASK);
    eval 'sub ESR_ELx_EXCEPTION {
        my($esr) = @_;
	    eval q(((($esr) &  &ESR_ELx_EC_MASK) >>  &ESR_ELx_EC_SHIFT));
    }' unless defined(&ESR_ELx_EXCEPTION);
    eval 'sub EXCP_UNKNOWN () {0x;}' unless defined(&EXCP_UNKNOWN);
    eval 'sub EXCP_FP_SIMD () {0x7;}' unless defined(&EXCP_FP_SIMD);
    eval 'sub EXCP_ILL_STATE () {0xe;}' unless defined(&EXCP_ILL_STATE);
    eval 'sub EXCP_SVC32 () {0x11;}' unless defined(&EXCP_SVC32);
    eval 'sub EXCP_SVC64 () {0x15;}' unless defined(&EXCP_SVC64);
    eval 'sub EXCP_MSR () {0x18;}' unless defined(&EXCP_MSR);
    eval 'sub EXCP_INSN_ABORT_L () {0x20;}' unless defined(&EXCP_INSN_ABORT_L);
    eval 'sub EXCP_INSN_ABORT () {0x21;}' unless defined(&EXCP_INSN_ABORT);
    eval 'sub EXCP_PC_ALIGN () {0x22;}' unless defined(&EXCP_PC_ALIGN);
    eval 'sub EXCP_DATA_ABORT_L () {0x24;}' unless defined(&EXCP_DATA_ABORT_L);
    eval 'sub EXCP_DATA_ABORT () {0x25;}' unless defined(&EXCP_DATA_ABORT);
    eval 'sub EXCP_SP_ALIGN () {0x26;}' unless defined(&EXCP_SP_ALIGN);
    eval 'sub EXCP_TRAP_FP () {0x2c;}' unless defined(&EXCP_TRAP_FP);
    eval 'sub EXCP_SERROR () {0x2f;}' unless defined(&EXCP_SERROR);
    eval 'sub EXCP_SOFTSTP_EL0 () {0x32;}' unless defined(&EXCP_SOFTSTP_EL0);
    eval 'sub EXCP_SOFTSTP_EL1 () {0x33;}' unless defined(&EXCP_SOFTSTP_EL1);
    eval 'sub EXCP_WATCHPT_EL1 () {0x35;}' unless defined(&EXCP_WATCHPT_EL1);
    eval 'sub EXCP_BRK () {0x3c;}' unless defined(&EXCP_BRK);
    eval 'sub ICC_CTLR_EL1_EOIMODE () {(1 << 1);}' unless defined(&ICC_CTLR_EL1_EOIMODE);
    eval 'sub ICC_IAR1_EL1_SPUR () {(0x3ff);}' unless defined(&ICC_IAR1_EL1_SPUR);
    eval 'sub ICC_IGRPEN0_EL1_EN () {(1 << 0);}' unless defined(&ICC_IGRPEN0_EL1_EN);
    eval 'sub ICC_PMR_EL1_PRIO_MASK () {(0xff);}' unless defined(&ICC_PMR_EL1_PRIO_MASK);
    eval 'sub ICC_SGI1R_EL1_TL_MASK () {0xffff;}' unless defined(&ICC_SGI1R_EL1_TL_MASK);
    eval 'sub ICC_SGI1R_EL1_AFF1_SHIFT () {16;}' unless defined(&ICC_SGI1R_EL1_AFF1_SHIFT);
    eval 'sub ICC_SGI1R_EL1_SGIID_SHIFT () {24;}' unless defined(&ICC_SGI1R_EL1_SGIID_SHIFT);
    eval 'sub ICC_SGI1R_EL1_AFF2_SHIFT () {32;}' unless defined(&ICC_SGI1R_EL1_AFF2_SHIFT);
    eval 'sub ICC_SGI1R_EL1_AFF3_SHIFT () {48;}' unless defined(&ICC_SGI1R_EL1_AFF3_SHIFT);
    eval 'sub ICC_SGI1R_EL1_SGIID_MASK () {0xf;}' unless defined(&ICC_SGI1R_EL1_SGIID_MASK);
    eval 'sub ICC_SGI1R_EL1_IRM () {(0x1 << 40);}' unless defined(&ICC_SGI1R_EL1_IRM);
    eval 'sub ICC_SRE_EL1_SRE () {(1 << 0);}' unless defined(&ICC_SRE_EL1_SRE);
    eval 'sub ICC_SRE_EL2_SRE () {(1 << 0);}' unless defined(&ICC_SRE_EL2_SRE);
    eval 'sub ICC_SRE_EL2_EN () {(1 << 3);}' unless defined(&ICC_SRE_EL2_EN);
    eval 'sub ID_AA64DFR0_MASK () { &UL(0xff0f0ffff);}' unless defined(&ID_AA64DFR0_MASK);
    eval 'sub ID_AA64DFR0_DebugVer_SHIFT () {0;}' unless defined(&ID_AA64DFR0_DebugVer_SHIFT);
    eval 'sub ID_AA64DFR0_DebugVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_MASK);
    eval 'sub ID_AA64DFR0_DebugVer {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_DebugVer_MASK));
    }' unless defined(&ID_AA64DFR0_DebugVer);
    eval 'sub ID_AA64DFR0_DebugVer_8 () {( &UL(0x6) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8);
    eval 'sub ID_AA64DFR0_DebugVer_8_VHE () {( &UL(0x7) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8_VHE);
    eval 'sub ID_AA64DFR0_DebugVer_8_2 () {( &UL(0x8) <<  &ID_AA64DFR0_DebugVer_SHIFT);}' unless defined(&ID_AA64DFR0_DebugVer_8_2);
    eval 'sub ID_AA64DFR0_TraceVer_SHIFT () {4;}' unless defined(&ID_AA64DFR0_TraceVer_SHIFT);
    eval 'sub ID_AA64DFR0_TraceVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_TraceVer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceVer_MASK);
    eval 'sub ID_AA64DFR0_TraceVer {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_TraceVer_MASK));
    }' unless defined(&ID_AA64DFR0_TraceVer);
    eval 'sub ID_AA64DFR0_TraceVer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_TraceVer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceVer_NONE);
    eval 'sub ID_AA64DFR0_TraceVer_IMPL () {( &UL(0x1) <<  &ID_AA64DFR0_TraceVer_SHIFT);}' unless defined(&ID_AA64DFR0_TraceVer_IMPL);
    eval 'sub ID_AA64DFR0_PMUVer_SHIFT () {8;}' unless defined(&ID_AA64DFR0_PMUVer_SHIFT);
    eval 'sub ID_AA64DFR0_PMUVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_MASK);
    eval 'sub ID_AA64DFR0_PMUVer {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_PMUVer_MASK));
    }' unless defined(&ID_AA64DFR0_PMUVer);
    eval 'sub ID_AA64DFR0_PMUVer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_NONE);
    eval 'sub ID_AA64DFR0_PMUVer_3 () {( &UL(0x1) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3);
    eval 'sub ID_AA64DFR0_PMUVer_3_1 () {( &UL(0x4) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_3_1);
    eval 'sub ID_AA64DFR0_PMUVer_IMPL () {( &UL(0xf) <<  &ID_AA64DFR0_PMUVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMUVer_IMPL);
    eval 'sub ID_AA64DFR0_BRPs_SHIFT () {12;}' unless defined(&ID_AA64DFR0_BRPs_SHIFT);
    eval 'sub ID_AA64DFR0_BRPs_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_BRPs_SHIFT);}' unless defined(&ID_AA64DFR0_BRPs_MASK);
    eval 'sub ID_AA64DFR0_BRPs {
        my($x) = @_;
	    eval q((((($x) >>  &ID_AA64DFR0_BRPs_SHIFT) & 0xf) + 1));
    }' unless defined(&ID_AA64DFR0_BRPs);
    eval 'sub ID_AA64DFR0_WRPs_SHIFT () {20;}' unless defined(&ID_AA64DFR0_WRPs_SHIFT);
    eval 'sub ID_AA64DFR0_WRPs_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_WRPs_SHIFT);}' unless defined(&ID_AA64DFR0_WRPs_MASK);
    eval 'sub ID_AA64DFR0_WRPs {
        my($x) = @_;
	    eval q((((($x) >>  &ID_AA64DFR0_WRPs_SHIFT) & 0xf) + 1));
    }' unless defined(&ID_AA64DFR0_WRPs);
    eval 'sub ID_AA64DFR0_CTX_CMPs_SHIFT () {28;}' unless defined(&ID_AA64DFR0_CTX_CMPs_SHIFT);
    eval 'sub ID_AA64DFR0_CTX_CMPs_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_CTX_CMPs_SHIFT);}' unless defined(&ID_AA64DFR0_CTX_CMPs_MASK);
    eval 'sub ID_AA64DFR0_CTX_CMPs {
        my($x) = @_;
	    eval q((((($x) >>  &ID_AA64DFR0_CTX_CMPs_SHIFT) & 0xf) + 1));
    }' unless defined(&ID_AA64DFR0_CTX_CMPs);
    eval 'sub ID_AA64DFR0_PMSVer_SHIFT () {32;}' unless defined(&ID_AA64DFR0_PMSVer_SHIFT);
    eval 'sub ID_AA64DFR0_PMSVer_MASK () {( &UL(0xf) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_MASK);
    eval 'sub ID_AA64DFR0_PMSVer {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64DFR0_PMSVer_MASK));
    }' unless defined(&ID_AA64DFR0_PMSVer);
    eval 'sub ID_AA64DFR0_PMSVer_NONE () {( &UL(0x) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_NONE);
    eval 'sub ID_AA64DFR0_PMSVer_V1 () {( &UL(0x1) <<  &ID_AA64DFR0_PMSVer_SHIFT);}' unless defined(&ID_AA64DFR0_PMSVer_V1);
    eval 'sub ID_AA64ISAR0_MASK () { &UL(0xfffff0fffff0);}' unless defined(&ID_AA64ISAR0_MASK);
    eval 'sub ID_AA64ISAR0_AES_SHIFT () {4;}' unless defined(&ID_AA64ISAR0_AES_SHIFT);
    eval 'sub ID_AA64ISAR0_AES_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_MASK);
    eval 'sub ID_AA64ISAR0_AES {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_AES_MASK));
    }' unless defined(&ID_AA64ISAR0_AES);
    eval 'sub ID_AA64ISAR0_AES_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_NONE);
    eval 'sub ID_AA64ISAR0_AES_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_BASE);
    eval 'sub ID_AA64ISAR0_AES_PMULL () {( &UL(0x2) <<  &ID_AA64ISAR0_AES_SHIFT);}' unless defined(&ID_AA64ISAR0_AES_PMULL);
    eval 'sub ID_AA64ISAR0_SHA1_SHIFT () {8;}' unless defined(&ID_AA64ISAR0_SHA1_SHIFT);
    eval 'sub ID_AA64ISAR0_SHA1_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_MASK);
    eval 'sub ID_AA64ISAR0_SHA1 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SHA1_MASK));
    }' unless defined(&ID_AA64ISAR0_SHA1);
    eval 'sub ID_AA64ISAR0_SHA1_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_NONE);
    eval 'sub ID_AA64ISAR0_SHA1_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_SHA1_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA1_BASE);
    eval 'sub ID_AA64ISAR0_SHA2_SHIFT () {12;}' unless defined(&ID_AA64ISAR0_SHA2_SHIFT);
    eval 'sub ID_AA64ISAR0_SHA2_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_MASK);
    eval 'sub ID_AA64ISAR0_SHA2 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SHA2_MASK));
    }' unless defined(&ID_AA64ISAR0_SHA2);
    eval 'sub ID_AA64ISAR0_SHA2_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_NONE);
    eval 'sub ID_AA64ISAR0_SHA2_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_BASE);
    eval 'sub ID_AA64ISAR0_SHA2_512 () {( &UL(0x2) <<  &ID_AA64ISAR0_SHA2_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA2_512);
    eval 'sub ID_AA64ISAR0_CRC32_SHIFT () {16;}' unless defined(&ID_AA64ISAR0_CRC32_SHIFT);
    eval 'sub ID_AA64ISAR0_CRC32_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_MASK);
    eval 'sub ID_AA64ISAR0_CRC32 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_CRC32_MASK));
    }' unless defined(&ID_AA64ISAR0_CRC32);
    eval 'sub ID_AA64ISAR0_CRC32_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_NONE);
    eval 'sub ID_AA64ISAR0_CRC32_BASE () {( &UL(0x1) <<  &ID_AA64ISAR0_CRC32_SHIFT);}' unless defined(&ID_AA64ISAR0_CRC32_BASE);
    eval 'sub ID_AA64ISAR0_Atomic_SHIFT () {20;}' unless defined(&ID_AA64ISAR0_Atomic_SHIFT);
    eval 'sub ID_AA64ISAR0_Atomic_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_Atomic_SHIFT);}' unless defined(&ID_AA64ISAR0_Atomic_MASK);
    eval 'sub ID_AA64ISAR0_Atomic {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_Atomic_MASK));
    }' unless defined(&ID_AA64ISAR0_Atomic);
    eval 'sub ID_AA64ISAR0_Atomic_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_Atomic_SHIFT);}' unless defined(&ID_AA64ISAR0_Atomic_NONE);
    eval 'sub ID_AA64ISAR0_Atomic_IMPL () {( &UL(0x2) <<  &ID_AA64ISAR0_Atomic_SHIFT);}' unless defined(&ID_AA64ISAR0_Atomic_IMPL);
    eval 'sub ID_AA64ISAR0_RDM_SHIFT () {28;}' unless defined(&ID_AA64ISAR0_RDM_SHIFT);
    eval 'sub ID_AA64ISAR0_RDM_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_MASK);
    eval 'sub ID_AA64ISAR0_RDM {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_RDM_MASK));
    }' unless defined(&ID_AA64ISAR0_RDM);
    eval 'sub ID_AA64ISAR0_RDM_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_NONE);
    eval 'sub ID_AA64ISAR0_RDM_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_RDM_SHIFT);}' unless defined(&ID_AA64ISAR0_RDM_IMPL);
    eval 'sub ID_AA64ISAR0_SHA3_SHIFT () {32;}' unless defined(&ID_AA64ISAR0_SHA3_SHIFT);
    eval 'sub ID_AA64ISAR0_SHA3_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SHA3_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA3_MASK);
    eval 'sub ID_AA64ISAR0_SHA3 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SHA3_MASK));
    }' unless defined(&ID_AA64ISAR0_SHA3);
    eval 'sub ID_AA64ISAR0_SHA3_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SHA3_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA3_NONE);
    eval 'sub ID_AA64ISAR0_SHA3_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_SHA3_SHIFT);}' unless defined(&ID_AA64ISAR0_SHA3_IMPL);
    eval 'sub ID_AA64ISAR0_SM3_SHIFT () {36;}' unless defined(&ID_AA64ISAR0_SM3_SHIFT);
    eval 'sub ID_AA64ISAR0_SM3_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SM3_SHIFT);}' unless defined(&ID_AA64ISAR0_SM3_MASK);
    eval 'sub ID_AA64ISAR0_SM3 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SM3_MASK));
    }' unless defined(&ID_AA64ISAR0_SM3);
    eval 'sub ID_AA64ISAR0_SM3_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SM3_SHIFT);}' unless defined(&ID_AA64ISAR0_SM3_NONE);
    eval 'sub ID_AA64ISAR0_SM3_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_SM3_SHIFT);}' unless defined(&ID_AA64ISAR0_SM3_IMPL);
    eval 'sub ID_AA64ISAR0_SM4_SHIFT () {40;}' unless defined(&ID_AA64ISAR0_SM4_SHIFT);
    eval 'sub ID_AA64ISAR0_SM4_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_SM4_SHIFT);}' unless defined(&ID_AA64ISAR0_SM4_MASK);
    eval 'sub ID_AA64ISAR0_SM4 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_SM4_MASK));
    }' unless defined(&ID_AA64ISAR0_SM4);
    eval 'sub ID_AA64ISAR0_SM4_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_SM4_SHIFT);}' unless defined(&ID_AA64ISAR0_SM4_NONE);
    eval 'sub ID_AA64ISAR0_SM4_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_SM4_SHIFT);}' unless defined(&ID_AA64ISAR0_SM4_IMPL);
    eval 'sub ID_AA64ISAR0_DP_SHIFT () {44;}' unless defined(&ID_AA64ISAR0_DP_SHIFT);
    eval 'sub ID_AA64ISAR0_DP_MASK () {( &UL(0xf) <<  &ID_AA64ISAR0_DP_SHIFT);}' unless defined(&ID_AA64ISAR0_DP_MASK);
    eval 'sub ID_AA64ISAR0_DP {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR0_DP_MASK));
    }' unless defined(&ID_AA64ISAR0_DP);
    eval 'sub ID_AA64ISAR0_DP_NONE () {( &UL(0x) <<  &ID_AA64ISAR0_DP_SHIFT);}' unless defined(&ID_AA64ISAR0_DP_NONE);
    eval 'sub ID_AA64ISAR0_DP_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR0_DP_SHIFT);}' unless defined(&ID_AA64ISAR0_DP_IMPL);
    eval 'sub ID_AA64ISAR1_MASK () { &UL(0xffffffff);}' unless defined(&ID_AA64ISAR1_MASK);
    eval 'sub ID_AA64ISAR1_DPB_SHIFT () {0;}' unless defined(&ID_AA64ISAR1_DPB_SHIFT);
    eval 'sub ID_AA64ISAR1_DPB_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_MASK);
    eval 'sub ID_AA64ISAR1_DPB {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_DPB_MASK));
    }' unless defined(&ID_AA64ISAR1_DPB);
    eval 'sub ID_AA64ISAR1_DPB_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_NONE);
    eval 'sub ID_AA64ISAR1_DPB_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_DPB_SHIFT);}' unless defined(&ID_AA64ISAR1_DPB_IMPL);
    eval 'sub ID_AA64ISAR1_APA_SHIFT () {4;}' unless defined(&ID_AA64ISAR1_APA_SHIFT);
    eval 'sub ID_AA64ISAR1_APA_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_MASK);
    eval 'sub ID_AA64ISAR1_APA {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_APA_MASK));
    }' unless defined(&ID_AA64ISAR1_APA);
    eval 'sub ID_AA64ISAR1_APA_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_NONE);
    eval 'sub ID_AA64ISAR1_APA_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_APA_SHIFT);}' unless defined(&ID_AA64ISAR1_APA_IMPL);
    eval 'sub ID_AA64ISAR1_API_SHIFT () {8;}' unless defined(&ID_AA64ISAR1_API_SHIFT);
    eval 'sub ID_AA64ISAR1_API_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_MASK);
    eval 'sub ID_AA64ISAR1_API {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_API_MASK));
    }' unless defined(&ID_AA64ISAR1_API);
    eval 'sub ID_AA64ISAR1_API_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_NONE);
    eval 'sub ID_AA64ISAR1_API_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_API_SHIFT);}' unless defined(&ID_AA64ISAR1_API_IMPL);
    eval 'sub ID_AA64ISAR1_JSCVT_SHIFT () {12;}' unless defined(&ID_AA64ISAR1_JSCVT_SHIFT);
    eval 'sub ID_AA64ISAR1_JSCVT_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_JSCVT_SHIFT);}' unless defined(&ID_AA64ISAR1_JSCVT_MASK);
    eval 'sub ID_AA64ISAR1_JSCVT {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_JSCVT_MASK));
    }' unless defined(&ID_AA64ISAR1_JSCVT);
    eval 'sub ID_AA64ISAR1_JSCVT_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_JSCVT_SHIFT);}' unless defined(&ID_AA64ISAR1_JSCVT_NONE);
    eval 'sub ID_AA64ISAR1_JSCVT_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_JSCVT_SHIFT);}' unless defined(&ID_AA64ISAR1_JSCVT_IMPL);
    eval 'sub ID_AA64ISAR1_FCMA_SHIFT () {16;}' unless defined(&ID_AA64ISAR1_FCMA_SHIFT);
    eval 'sub ID_AA64ISAR1_FCMA_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_FCMA_SHIFT);}' unless defined(&ID_AA64ISAR1_FCMA_MASK);
    eval 'sub ID_AA64ISAR1_FCMA {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_FCMA_MASK));
    }' unless defined(&ID_AA64ISAR1_FCMA);
    eval 'sub ID_AA64ISAR1_FCMA_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_FCMA_SHIFT);}' unless defined(&ID_AA64ISAR1_FCMA_NONE);
    eval 'sub ID_AA64ISAR1_FCMA_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_FCMA_SHIFT);}' unless defined(&ID_AA64ISAR1_FCMA_IMPL);
    eval 'sub ID_AA64ISAR1_LRCPC_SHIFT () {20;}' unless defined(&ID_AA64ISAR1_LRCPC_SHIFT);
    eval 'sub ID_AA64ISAR1_LRCPC_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_MASK);
    eval 'sub ID_AA64ISAR1_LRCPC {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_LRCPC_MASK));
    }' unless defined(&ID_AA64ISAR1_LRCPC);
    eval 'sub ID_AA64ISAR1_LRCPC_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_NONE);
    eval 'sub ID_AA64ISAR1_LRCPC_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_LRCPC_SHIFT);}' unless defined(&ID_AA64ISAR1_LRCPC_IMPL);
    eval 'sub ID_AA64ISAR1_GPA_SHIFT () {24;}' unless defined(&ID_AA64ISAR1_GPA_SHIFT);
    eval 'sub ID_AA64ISAR1_GPA_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_GPA_SHIFT);}' unless defined(&ID_AA64ISAR1_GPA_MASK);
    eval 'sub ID_AA64ISAR1_GPA {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_GPA_MASK));
    }' unless defined(&ID_AA64ISAR1_GPA);
    eval 'sub ID_AA64ISAR1_GPA_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_GPA_SHIFT);}' unless defined(&ID_AA64ISAR1_GPA_NONE);
    eval 'sub ID_AA64ISAR1_GPA_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_GPA_SHIFT);}' unless defined(&ID_AA64ISAR1_GPA_IMPL);
    eval 'sub ID_AA64ISAR1_GPI_SHIFT () {28;}' unless defined(&ID_AA64ISAR1_GPI_SHIFT);
    eval 'sub ID_AA64ISAR1_GPI_MASK () {( &UL(0xf) <<  &ID_AA64ISAR1_GPI_SHIFT);}' unless defined(&ID_AA64ISAR1_GPI_MASK);
    eval 'sub ID_AA64ISAR1_GPI {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64ISAR1_GPI_MASK));
    }' unless defined(&ID_AA64ISAR1_GPI);
    eval 'sub ID_AA64ISAR1_GPI_NONE () {( &UL(0x) <<  &ID_AA64ISAR1_GPI_SHIFT);}' unless defined(&ID_AA64ISAR1_GPI_NONE);
    eval 'sub ID_AA64ISAR1_GPI_IMPL () {( &UL(0x1) <<  &ID_AA64ISAR1_GPI_SHIFT);}' unless defined(&ID_AA64ISAR1_GPI_IMPL);
    eval 'sub ID_AA64MMFR0_MASK () { &UL(0xffffffff);}' unless defined(&ID_AA64MMFR0_MASK);
    eval 'sub ID_AA64MMFR0_PARange_SHIFT () {0;}' unless defined(&ID_AA64MMFR0_PARange_SHIFT);
    eval 'sub ID_AA64MMFR0_PARange_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_MASK);
    eval 'sub ID_AA64MMFR0_PARange {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_PARange_MASK));
    }' unless defined(&ID_AA64MMFR0_PARange);
    eval 'sub ID_AA64MMFR0_PARange_4G () {( &UL(0x) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_4G);
    eval 'sub ID_AA64MMFR0_PARange_64G () {( &UL(0x1) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_64G);
    eval 'sub ID_AA64MMFR0_PARange_1T () {( &UL(0x2) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_1T);
    eval 'sub ID_AA64MMFR0_PARange_4T () {( &UL(0x3) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_4T);
    eval 'sub ID_AA64MMFR0_PARange_16T () {( &UL(0x4) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_16T);
    eval 'sub ID_AA64MMFR0_PARange_256T () {( &UL(0x5) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_256T);
    eval 'sub ID_AA64MMFR0_PARange_4P () {( &UL(0x6) <<  &ID_AA64MMFR0_PARange_SHIFT);}' unless defined(&ID_AA64MMFR0_PARange_4P);
    eval 'sub ID_AA64MMFR0_ASIDBits_SHIFT () {4;}' unless defined(&ID_AA64MMFR0_ASIDBits_SHIFT);
    eval 'sub ID_AA64MMFR0_ASIDBits_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_ASIDBits_SHIFT);}' unless defined(&ID_AA64MMFR0_ASIDBits_MASK);
    eval 'sub ID_AA64MMFR0_ASIDBits {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_ASIDBits_MASK));
    }' unless defined(&ID_AA64MMFR0_ASIDBits);
    eval 'sub ID_AA64MMFR0_ASIDBits_8 () {( &UL(0x) <<  &ID_AA64MMFR0_ASIDBits_SHIFT);}' unless defined(&ID_AA64MMFR0_ASIDBits_8);
    eval 'sub ID_AA64MMFR0_ASIDBits_16 () {( &UL(0x2) <<  &ID_AA64MMFR0_ASIDBits_SHIFT);}' unless defined(&ID_AA64MMFR0_ASIDBits_16);
    eval 'sub ID_AA64MMFR0_BigEnd_SHIFT () {8;}' unless defined(&ID_AA64MMFR0_BigEnd_SHIFT);
    eval 'sub ID_AA64MMFR0_BigEnd_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_BigEnd_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEnd_MASK);
    eval 'sub ID_AA64MMFR0_BigEnd {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_BigEnd_MASK));
    }' unless defined(&ID_AA64MMFR0_BigEnd);
    eval 'sub ID_AA64MMFR0_BigEnd_FIXED () {( &UL(0x) <<  &ID_AA64MMFR0_BigEnd_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEnd_FIXED);
    eval 'sub ID_AA64MMFR0_BigEnd_MIXED () {( &UL(0x1) <<  &ID_AA64MMFR0_BigEnd_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEnd_MIXED);
    eval 'sub ID_AA64MMFR0_SNSMem_SHIFT () {12;}' unless defined(&ID_AA64MMFR0_SNSMem_SHIFT);
    eval 'sub ID_AA64MMFR0_SNSMem_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_SNSMem_SHIFT);}' unless defined(&ID_AA64MMFR0_SNSMem_MASK);
    eval 'sub ID_AA64MMFR0_SNSMem {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_SNSMem_MASK));
    }' unless defined(&ID_AA64MMFR0_SNSMem);
    eval 'sub ID_AA64MMFR0_SNSMem_NONE () {( &UL(0x) <<  &ID_AA64MMFR0_SNSMem_SHIFT);}' unless defined(&ID_AA64MMFR0_SNSMem_NONE);
    eval 'sub ID_AA64MMFR0_SNSMem_DISTINCT () {( &UL(0x1) <<  &ID_AA64MMFR0_SNSMem_SHIFT);}' unless defined(&ID_AA64MMFR0_SNSMem_DISTINCT);
    eval 'sub ID_AA64MMFR0_BigEndEL0_SHIFT () {16;}' unless defined(&ID_AA64MMFR0_BigEndEL0_SHIFT);
    eval 'sub ID_AA64MMFR0_BigEndEL0_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_BigEndEL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEndEL0_MASK);
    eval 'sub ID_AA64MMFR0_BigEndEL0 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_BigEndEL0_MASK));
    }' unless defined(&ID_AA64MMFR0_BigEndEL0);
    eval 'sub ID_AA64MMFR0_BigEndEL0_FIXED () {( &UL(0x) <<  &ID_AA64MMFR0_BigEndEL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEndEL0_FIXED);
    eval 'sub ID_AA64MMFR0_BigEndEL0_MIXED () {( &UL(0x1) <<  &ID_AA64MMFR0_BigEndEL0_SHIFT);}' unless defined(&ID_AA64MMFR0_BigEndEL0_MIXED);
    eval 'sub ID_AA64MMFR0_TGran16_SHIFT () {20;}' unless defined(&ID_AA64MMFR0_TGran16_SHIFT);
    eval 'sub ID_AA64MMFR0_TGran16_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_MASK);
    eval 'sub ID_AA64MMFR0_TGran16 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_TGran16_MASK));
    }' unless defined(&ID_AA64MMFR0_TGran16);
    eval 'sub ID_AA64MMFR0_TGran16_NONE () {( &UL(0x) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_NONE);
    eval 'sub ID_AA64MMFR0_TGran16_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR0_TGran16_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran16_IMPL);
    eval 'sub ID_AA64MMFR0_TGran64_SHIFT () {24;}' unless defined(&ID_AA64MMFR0_TGran64_SHIFT);
    eval 'sub ID_AA64MMFR0_TGran64_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_MASK);
    eval 'sub ID_AA64MMFR0_TGran64 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_TGran64_MASK));
    }' unless defined(&ID_AA64MMFR0_TGran64);
    eval 'sub ID_AA64MMFR0_TGran64_IMPL () {( &UL(0x) <<  &ID_AA64MMFR0_TGran64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_IMPL);
    eval 'sub ID_AA64MMFR0_TGran64_NONE () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran64_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran64_NONE);
    eval 'sub ID_AA64MMFR0_TGran4_SHIFT () {28;}' unless defined(&ID_AA64MMFR0_TGran4_SHIFT);
    eval 'sub ID_AA64MMFR0_TGran4_MASK () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_MASK);
    eval 'sub ID_AA64MMFR0_TGran4 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR0_TGran4_MASK));
    }' unless defined(&ID_AA64MMFR0_TGran4);
    eval 'sub ID_AA64MMFR0_TGran4_IMPL () {( &UL(0x) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_IMPL);
    eval 'sub ID_AA64MMFR0_TGran4_NONE () {( &UL(0xf) <<  &ID_AA64MMFR0_TGran4_SHIFT);}' unless defined(&ID_AA64MMFR0_TGran4_NONE);
    eval 'sub ID_AA64MMFR1_MASK () { &UL(0xffffffff);}' unless defined(&ID_AA64MMFR1_MASK);
    eval 'sub ID_AA64MMFR1_HAFDBS_SHIFT () {0;}' unless defined(&ID_AA64MMFR1_HAFDBS_SHIFT);
    eval 'sub ID_AA64MMFR1_HAFDBS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_MASK);
    eval 'sub ID_AA64MMFR1_HAFDBS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_HAFDBS_MASK));
    }' unless defined(&ID_AA64MMFR1_HAFDBS);
    eval 'sub ID_AA64MMFR1_HAFDBS_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_NONE);
    eval 'sub ID_AA64MMFR1_HAFDBS_AF () {( &UL(0x1) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_AF);
    eval 'sub ID_AA64MMFR1_HAFDBS_AF_DBS () {( &UL(0x2) <<  &ID_AA64MMFR1_HAFDBS_SHIFT);}' unless defined(&ID_AA64MMFR1_HAFDBS_AF_DBS);
    eval 'sub ID_AA64MMFR1_VMIDBits_SHIFT () {4;}' unless defined(&ID_AA64MMFR1_VMIDBits_SHIFT);
    eval 'sub ID_AA64MMFR1_VMIDBits_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_VMIDBits_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBits_MASK);
    eval 'sub ID_AA64MMFR1_VMIDBits {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_VMIDBits_MASK));
    }' unless defined(&ID_AA64MMFR1_VMIDBits);
    eval 'sub ID_AA64MMFR1_VMIDBits_8 () {( &UL(0x) <<  &ID_AA64MMFR1_VMIDBits_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBits_8);
    eval 'sub ID_AA64MMFR1_VMIDBits_16 () {( &UL(0x2) <<  &ID_AA64MMFR1_VMIDBits_SHIFT);}' unless defined(&ID_AA64MMFR1_VMIDBits_16);
    eval 'sub ID_AA64MMFR1_VH_SHIFT () {8;}' unless defined(&ID_AA64MMFR1_VH_SHIFT);
    eval 'sub ID_AA64MMFR1_VH_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_MASK);
    eval 'sub ID_AA64MMFR1_VH {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_VH_MASK));
    }' unless defined(&ID_AA64MMFR1_VH);
    eval 'sub ID_AA64MMFR1_VH_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_NONE);
    eval 'sub ID_AA64MMFR1_VH_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_VH_SHIFT);}' unless defined(&ID_AA64MMFR1_VH_IMPL);
    eval 'sub ID_AA64MMFR1_HPDS_SHIFT () {12;}' unless defined(&ID_AA64MMFR1_HPDS_SHIFT);
    eval 'sub ID_AA64MMFR1_HPDS_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_MASK);
    eval 'sub ID_AA64MMFR1_HPDS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_HPDS_MASK));
    }' unless defined(&ID_AA64MMFR1_HPDS);
    eval 'sub ID_AA64MMFR1_HPDS_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_NONE);
    eval 'sub ID_AA64MMFR1_HPDS_HPD () {( &UL(0x1) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_HPD);
    eval 'sub ID_AA64MMFR1_HPDS_TTPBHA () {( &UL(0x2) <<  &ID_AA64MMFR1_HPDS_SHIFT);}' unless defined(&ID_AA64MMFR1_HPDS_TTPBHA);
    eval 'sub ID_AA64MMFR1_LO_SHIFT () {16;}' unless defined(&ID_AA64MMFR1_LO_SHIFT);
    eval 'sub ID_AA64MMFR1_LO_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_MASK);
    eval 'sub ID_AA64MMFR1_LO {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_LO_MASK));
    }' unless defined(&ID_AA64MMFR1_LO);
    eval 'sub ID_AA64MMFR1_LO_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_NONE);
    eval 'sub ID_AA64MMFR1_LO_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_LO_SHIFT);}' unless defined(&ID_AA64MMFR1_LO_IMPL);
    eval 'sub ID_AA64MMFR1_PAN_SHIFT () {20;}' unless defined(&ID_AA64MMFR1_PAN_SHIFT);
    eval 'sub ID_AA64MMFR1_PAN_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_MASK);
    eval 'sub ID_AA64MMFR1_PAN {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_PAN_MASK));
    }' unless defined(&ID_AA64MMFR1_PAN);
    eval 'sub ID_AA64MMFR1_PAN_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_NONE);
    eval 'sub ID_AA64MMFR1_PAN_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_IMPL);
    eval 'sub ID_AA64MMFR1_PAN_ATS1E1 () {( &UL(0x2) <<  &ID_AA64MMFR1_PAN_SHIFT);}' unless defined(&ID_AA64MMFR1_PAN_ATS1E1);
    eval 'sub ID_AA64MMFR1_SpecSEI_SHIFT () {24;}' unless defined(&ID_AA64MMFR1_SpecSEI_SHIFT);
    eval 'sub ID_AA64MMFR1_SpecSEI_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_SpecSEI_SHIFT);}' unless defined(&ID_AA64MMFR1_SpecSEI_MASK);
    eval 'sub ID_AA64MMFR1_SpecSEI {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_SpecSEI_MASK));
    }' unless defined(&ID_AA64MMFR1_SpecSEI);
    eval 'sub ID_AA64MMFR1_SpecSEI_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_SpecSEI_SHIFT);}' unless defined(&ID_AA64MMFR1_SpecSEI_NONE);
    eval 'sub ID_AA64MMFR1_SpecSEI_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_SpecSEI_SHIFT);}' unless defined(&ID_AA64MMFR1_SpecSEI_IMPL);
    eval 'sub ID_AA64MMFR1_XNX_SHIFT () {28;}' unless defined(&ID_AA64MMFR1_XNX_SHIFT);
    eval 'sub ID_AA64MMFR1_XNX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR1_XNX_SHIFT);}' unless defined(&ID_AA64MMFR1_XNX_MASK);
    eval 'sub ID_AA64MMFR1_XNX {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR1_XNX_MASK));
    }' unless defined(&ID_AA64MMFR1_XNX);
    eval 'sub ID_AA64MMFR1_XNX_NONE () {( &UL(0x) <<  &ID_AA64MMFR1_XNX_SHIFT);}' unless defined(&ID_AA64MMFR1_XNX_NONE);
    eval 'sub ID_AA64MMFR1_XNX_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR1_XNX_SHIFT);}' unless defined(&ID_AA64MMFR1_XNX_IMPL);
    eval 'sub ID_AA64MMFR2_EL1 () { &S3_0_C0_C7_2;}' unless defined(&ID_AA64MMFR2_EL1);
    eval 'sub ID_AA64MMFR2_MASK () { &UL(0xfffffff);}' unless defined(&ID_AA64MMFR2_MASK);
    eval 'sub ID_AA64MMFR2_CnP_SHIFT () {0;}' unless defined(&ID_AA64MMFR2_CnP_SHIFT);
    eval 'sub ID_AA64MMFR2_CnP_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_CnP_SHIFT);}' unless defined(&ID_AA64MMFR2_CnP_MASK);
    eval 'sub ID_AA64MMFR2_CnP {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_CnP_MASK));
    }' unless defined(&ID_AA64MMFR2_CnP);
    eval 'sub ID_AA64MMFR2_CnP_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_CnP_SHIFT);}' unless defined(&ID_AA64MMFR2_CnP_NONE);
    eval 'sub ID_AA64MMFR2_CnP_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_CnP_SHIFT);}' unless defined(&ID_AA64MMFR2_CnP_IMPL);
    eval 'sub ID_AA64MMFR2_UAO_SHIFT () {4;}' unless defined(&ID_AA64MMFR2_UAO_SHIFT);
    eval 'sub ID_AA64MMFR2_UAO_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_UAO_SHIFT);}' unless defined(&ID_AA64MMFR2_UAO_MASK);
    eval 'sub ID_AA64MMFR2_UAO {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_UAO_MASK));
    }' unless defined(&ID_AA64MMFR2_UAO);
    eval 'sub ID_AA64MMFR2_UAO_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_UAO_SHIFT);}' unless defined(&ID_AA64MMFR2_UAO_NONE);
    eval 'sub ID_AA64MMFR2_UAO_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_UAO_SHIFT);}' unless defined(&ID_AA64MMFR2_UAO_IMPL);
    eval 'sub ID_AA64MMFR2_LSM_SHIFT () {8;}' unless defined(&ID_AA64MMFR2_LSM_SHIFT);
    eval 'sub ID_AA64MMFR2_LSM_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_LSM_SHIFT);}' unless defined(&ID_AA64MMFR2_LSM_MASK);
    eval 'sub ID_AA64MMFR2_LSM {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_LSM_MASK));
    }' unless defined(&ID_AA64MMFR2_LSM);
    eval 'sub ID_AA64MMFR2_LSM_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_LSM_SHIFT);}' unless defined(&ID_AA64MMFR2_LSM_NONE);
    eval 'sub ID_AA64MMFR2_LSM_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_LSM_SHIFT);}' unless defined(&ID_AA64MMFR2_LSM_IMPL);
    eval 'sub ID_AA64MMFR2_IESB_SHIFT () {12;}' unless defined(&ID_AA64MMFR2_IESB_SHIFT);
    eval 'sub ID_AA64MMFR2_IESB_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_IESB_SHIFT);}' unless defined(&ID_AA64MMFR2_IESB_MASK);
    eval 'sub ID_AA64MMFR2_IESB {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_IESB_MASK));
    }' unless defined(&ID_AA64MMFR2_IESB);
    eval 'sub ID_AA64MMFR2_IESB_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_IESB_SHIFT);}' unless defined(&ID_AA64MMFR2_IESB_NONE);
    eval 'sub ID_AA64MMFR2_IESB_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_IESB_SHIFT);}' unless defined(&ID_AA64MMFR2_IESB_IMPL);
    eval 'sub ID_AA64MMFR2_VARange_SHIFT () {16;}' unless defined(&ID_AA64MMFR2_VARange_SHIFT);
    eval 'sub ID_AA64MMFR2_VARange_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_VARange_SHIFT);}' unless defined(&ID_AA64MMFR2_VARange_MASK);
    eval 'sub ID_AA64MMFR2_VARange {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_VARange_MASK));
    }' unless defined(&ID_AA64MMFR2_VARange);
    eval 'sub ID_AA64MMFR2_VARange_48 () {( &UL(0x) <<  &ID_AA64MMFR2_VARange_SHIFT);}' unless defined(&ID_AA64MMFR2_VARange_48);
    eval 'sub ID_AA64MMFR2_VARange_52 () {( &UL(0x1) <<  &ID_AA64MMFR2_VARange_SHIFT);}' unless defined(&ID_AA64MMFR2_VARange_52);
    eval 'sub ID_AA64MMFR2_CCIDX_SHIFT () {20;}' unless defined(&ID_AA64MMFR2_CCIDX_SHIFT);
    eval 'sub ID_AA64MMFR2_CCIDX_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_CCIDX_SHIFT);}' unless defined(&ID_AA64MMFR2_CCIDX_MASK);
    eval 'sub ID_AA64MMFR2_CCIDX {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_CCIDX_MASK));
    }' unless defined(&ID_AA64MMFR2_CCIDX);
    eval 'sub ID_AA64MMFR2_CCIDX_32 () {( &UL(0x) <<  &ID_AA64MMFR2_CCIDX_SHIFT);}' unless defined(&ID_AA64MMFR2_CCIDX_32);
    eval 'sub ID_AA64MMFR2_CCIDX_64 () {( &UL(0x1) <<  &ID_AA64MMFR2_CCIDX_SHIFT);}' unless defined(&ID_AA64MMFR2_CCIDX_64);
    eval 'sub ID_AA64MMFR2_NV_SHIFT () {24;}' unless defined(&ID_AA64MMFR2_NV_SHIFT);
    eval 'sub ID_AA64MMFR2_NV_MASK () {( &UL(0xf) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_MASK);
    eval 'sub ID_AA64MMFR2_NV {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64MMFR2_NV_MASK));
    }' unless defined(&ID_AA64MMFR2_NV);
    eval 'sub ID_AA64MMFR2_NV_NONE () {( &UL(0x) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_NONE);
    eval 'sub ID_AA64MMFR2_NV_IMPL () {( &UL(0x1) <<  &ID_AA64MMFR2_NV_SHIFT);}' unless defined(&ID_AA64MMFR2_NV_IMPL);
    eval 'sub ID_AA64PFR0_MASK () { &UL(0xfffffffff);}' unless defined(&ID_AA64PFR0_MASK);
    eval 'sub ID_AA64PFR0_EL0_SHIFT () {0;}' unless defined(&ID_AA64PFR0_EL0_SHIFT);
    eval 'sub ID_AA64PFR0_EL0_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_MASK);
    eval 'sub ID_AA64PFR0_EL0 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL0_MASK));
    }' unless defined(&ID_AA64PFR0_EL0);
    eval 'sub ID_AA64PFR0_EL0_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_64);
    eval 'sub ID_AA64PFR0_EL0_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL0_SHIFT);}' unless defined(&ID_AA64PFR0_EL0_64_32);
    eval 'sub ID_AA64PFR0_EL1_SHIFT () {4;}' unless defined(&ID_AA64PFR0_EL1_SHIFT);
    eval 'sub ID_AA64PFR0_EL1_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_MASK);
    eval 'sub ID_AA64PFR0_EL1 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL1_MASK));
    }' unless defined(&ID_AA64PFR0_EL1);
    eval 'sub ID_AA64PFR0_EL1_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_64);
    eval 'sub ID_AA64PFR0_EL1_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL1_SHIFT);}' unless defined(&ID_AA64PFR0_EL1_64_32);
    eval 'sub ID_AA64PFR0_EL2_SHIFT () {8;}' unless defined(&ID_AA64PFR0_EL2_SHIFT);
    eval 'sub ID_AA64PFR0_EL2_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_MASK);
    eval 'sub ID_AA64PFR0_EL2 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL2_MASK));
    }' unless defined(&ID_AA64PFR0_EL2);
    eval 'sub ID_AA64PFR0_EL2_NONE () {( &UL(0x) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_NONE);
    eval 'sub ID_AA64PFR0_EL2_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_64);
    eval 'sub ID_AA64PFR0_EL2_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL2_SHIFT);}' unless defined(&ID_AA64PFR0_EL2_64_32);
    eval 'sub ID_AA64PFR0_EL3_SHIFT () {12;}' unless defined(&ID_AA64PFR0_EL3_SHIFT);
    eval 'sub ID_AA64PFR0_EL3_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_MASK);
    eval 'sub ID_AA64PFR0_EL3 {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_EL3_MASK));
    }' unless defined(&ID_AA64PFR0_EL3);
    eval 'sub ID_AA64PFR0_EL3_NONE () {( &UL(0x) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_NONE);
    eval 'sub ID_AA64PFR0_EL3_64 () {( &UL(0x1) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_64);
    eval 'sub ID_AA64PFR0_EL3_64_32 () {( &UL(0x2) <<  &ID_AA64PFR0_EL3_SHIFT);}' unless defined(&ID_AA64PFR0_EL3_64_32);
    eval 'sub ID_AA64PFR0_FP_SHIFT () {16;}' unless defined(&ID_AA64PFR0_FP_SHIFT);
    eval 'sub ID_AA64PFR0_FP_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_MASK);
    eval 'sub ID_AA64PFR0_FP {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_FP_MASK));
    }' unless defined(&ID_AA64PFR0_FP);
    eval 'sub ID_AA64PFR0_FP_IMPL () {( &UL(0x) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_IMPL);
    eval 'sub ID_AA64PFR0_FP_HP () {( &UL(0x1) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_HP);
    eval 'sub ID_AA64PFR0_FP_NONE () {( &UL(0xf) <<  &ID_AA64PFR0_FP_SHIFT);}' unless defined(&ID_AA64PFR0_FP_NONE);
    eval 'sub ID_AA64PFR0_AdvSIMD_SHIFT () {20;}' unless defined(&ID_AA64PFR0_AdvSIMD_SHIFT);
    eval 'sub ID_AA64PFR0_AdvSIMD_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_MASK);
    eval 'sub ID_AA64PFR0_AdvSIMD {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_AdvSIMD_MASK));
    }' unless defined(&ID_AA64PFR0_AdvSIMD);
    eval 'sub ID_AA64PFR0_AdvSIMD_IMPL () {( &UL(0x) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_IMPL);
    eval 'sub ID_AA64PFR0_AdvSIMD_HP () {( &UL(0x1) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_HP);
    eval 'sub ID_AA64PFR0_AdvSIMD_NONE () {( &UL(0xf) <<  &ID_AA64PFR0_AdvSIMD_SHIFT);}' unless defined(&ID_AA64PFR0_AdvSIMD_NONE);
    eval 'sub ID_AA64PFR0_GIC_BITS () {0x4;}' unless defined(&ID_AA64PFR0_GIC_BITS);
    eval 'sub ID_AA64PFR0_GIC_SHIFT () {24;}' unless defined(&ID_AA64PFR0_GIC_SHIFT);
    eval 'sub ID_AA64PFR0_GIC_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_MASK);
    eval 'sub ID_AA64PFR0_GIC {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_GIC_MASK));
    }' unless defined(&ID_AA64PFR0_GIC);
    eval 'sub ID_AA64PFR0_GIC_CPUIF_NONE () {( &UL(0x) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_NONE);
    eval 'sub ID_AA64PFR0_GIC_CPUIF_EN () {( &UL(0x1) <<  &ID_AA64PFR0_GIC_SHIFT);}' unless defined(&ID_AA64PFR0_GIC_CPUIF_EN);
    eval 'sub ID_AA64PFR0_RAS_SHIFT () {28;}' unless defined(&ID_AA64PFR0_RAS_SHIFT);
    eval 'sub ID_AA64PFR0_RAS_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_MASK);
    eval 'sub ID_AA64PFR0_RAS {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_RAS_MASK));
    }' unless defined(&ID_AA64PFR0_RAS);
    eval 'sub ID_AA64PFR0_RAS_NONE () {( &UL(0x) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_NONE);
    eval 'sub ID_AA64PFR0_RAS_V1 () {( &UL(0x1) <<  &ID_AA64PFR0_RAS_SHIFT);}' unless defined(&ID_AA64PFR0_RAS_V1);
    eval 'sub ID_AA64PFR0_SVE_SHIFT () {32;}' unless defined(&ID_AA64PFR0_SVE_SHIFT);
    eval 'sub ID_AA64PFR0_SVE_MASK () {( &UL(0xf) <<  &ID_AA64PFR0_SVE_SHIFT);}' unless defined(&ID_AA64PFR0_SVE_MASK);
    eval 'sub ID_AA64PFR0_SVE {
        my($x) = @_;
	    eval q((($x) &  &ID_AA64PFR0_SVE_MASK));
    }' unless defined(&ID_AA64PFR0_SVE);
    eval 'sub ID_AA64PFR0_SVE_NONE () {( &UL(0x) <<  &ID_AA64PFR0_SVE_SHIFT);}' unless defined(&ID_AA64PFR0_SVE_NONE);
    eval 'sub ID_AA64PFR0_SVE_IMPL () {( &UL(0x1) <<  &ID_AA64PFR0_SVE_SHIFT);}' unless defined(&ID_AA64PFR0_SVE_IMPL);
    eval 'sub MAIR_ATTR_MASK {
        my($idx) = @_;
	    eval q((0xff << (( &n)* 8)));
    }' unless defined(&MAIR_ATTR_MASK);
    eval 'sub MAIR_ATTR {
        my($attr, $idx) = @_;
	    eval q((($attr) << (($idx) * 8)));
    }' unless defined(&MAIR_ATTR);
    eval 'sub MAIR_DEVICE_nGnRnE () {0x;}' unless defined(&MAIR_DEVICE_nGnRnE);
    eval 'sub MAIR_NORMAL_NC () {0x44;}' unless defined(&MAIR_NORMAL_NC);
    eval 'sub MAIR_NORMAL_WT () {0xbb;}' unless defined(&MAIR_NORMAL_WT);
    eval 'sub MAIR_NORMAL_WB () {0xff;}' unless defined(&MAIR_NORMAL_WB);
    eval 'sub PAR_F_SHIFT () {0;}' unless defined(&PAR_F_SHIFT);
    eval 'sub PAR_F () {(0x1 <<  &PAR_F_SHIFT);}' unless defined(&PAR_F);
    eval 'sub PAR_SUCCESS {
        my($x) = @_;
	    eval q(((($x) &  &PAR_F) == 0));
    }' unless defined(&PAR_SUCCESS);
    eval 'sub PAR_SH_SHIFT () {7;}' unless defined(&PAR_SH_SHIFT);
    eval 'sub PAR_SH_MASK () {(0x3 <<  &PAR_SH_SHIFT);}' unless defined(&PAR_SH_MASK);
    eval 'sub PAR_NS_SHIFT () {9;}' unless defined(&PAR_NS_SHIFT);
    eval 'sub PAR_NS_MASK () {(0x3 <<  &PAR_NS_SHIFT);}' unless defined(&PAR_NS_MASK);
    eval 'sub PAR_PA_SHIFT () {12;}' unless defined(&PAR_PA_SHIFT);
    eval 'sub PAR_PA_MASK () {0xfffffffff000;}' unless defined(&PAR_PA_MASK);
    eval 'sub PAR_ATTR_SHIFT () {56;}' unless defined(&PAR_ATTR_SHIFT);
    eval 'sub PAR_ATTR_MASK () {(0xff <<  &PAR_ATTR_SHIFT);}' unless defined(&PAR_ATTR_MASK);
    eval 'sub PAR_FST_SHIFT () {1;}' unless defined(&PAR_FST_SHIFT);
    eval 'sub PAR_FST_MASK () {(0x3f <<  &PAR_FST_SHIFT);}' unless defined(&PAR_FST_MASK);
    eval 'sub PAR_PTW_SHIFT () {8;}' unless defined(&PAR_PTW_SHIFT);
    eval 'sub PAR_PTW_MASK () {(0x1 <<  &PAR_PTW_SHIFT);}' unless defined(&PAR_PTW_MASK);
    eval 'sub PAR_S_SHIFT () {9;}' unless defined(&PAR_S_SHIFT);
    eval 'sub PAR_S_MASK () {(0x1 <<  &PAR_S_SHIFT);}' unless defined(&PAR_S_MASK);
    eval 'sub SCTLR_RES0 () {0xc8222440;}' unless defined(&SCTLR_RES0);
    eval 'sub SCTLR_RES1 () {0x30d00800;}' unless defined(&SCTLR_RES1);
    eval 'sub SCTLR_M () {0x1;}' unless defined(&SCTLR_M);
    eval 'sub SCTLR_A () {0x2;}' unless defined(&SCTLR_A);
    eval 'sub SCTLR_C () {0x4;}' unless defined(&SCTLR_C);
    eval 'sub SCTLR_SA () {0x8;}' unless defined(&SCTLR_SA);
    eval 'sub SCTLR_SA0 () {0x10;}' unless defined(&SCTLR_SA0);
    eval 'sub SCTLR_CP15BEN () {0x20;}' unless defined(&SCTLR_CP15BEN);
    eval 'sub SCTLR_ITD () {0x80;}' unless defined(&SCTLR_ITD);
    eval 'sub SCTLR_SED () {0x100;}' unless defined(&SCTLR_SED);
    eval 'sub SCTLR_UMA () {0x200;}' unless defined(&SCTLR_UMA);
    eval 'sub SCTLR_I () {0x1000;}' unless defined(&SCTLR_I);
    eval 'sub SCTLR_EnDB () {0x2000;}' unless defined(&SCTLR_EnDB);
    eval 'sub SCTLR_DZE () {0x4000;}' unless defined(&SCTLR_DZE);
    eval 'sub SCTLR_UCT () {0x8000;}' unless defined(&SCTLR_UCT);
    eval 'sub SCTLR_nTWI () {0x10000;}' unless defined(&SCTLR_nTWI);
    eval 'sub SCTLR_nTWE () {0x40000;}' unless defined(&SCTLR_nTWE);
    eval 'sub SCTLR_WXN () {0x80000;}' unless defined(&SCTLR_WXN);
    eval 'sub SCTLR_IESB () {0x200000;}' unless defined(&SCTLR_IESB);
    eval 'sub SCTLR_SPAN () {0x800000;}' unless defined(&SCTLR_SPAN);
    eval 'sub SCTLR_EOE () {0x1000000;}' unless defined(&SCTLR_EOE);
    eval 'sub SCTLR_EE () {0x2000000;}' unless defined(&SCTLR_EE);
    eval 'sub SCTLR_UCI () {0x4000000;}' unless defined(&SCTLR_UCI);
    eval 'sub SCTLR_EnDA () {0x8000000;}' unless defined(&SCTLR_EnDA);
    eval 'sub SCTLR_nTLSMD () {0x10000000;}' unless defined(&SCTLR_nTLSMD);
    eval 'sub SCTLR_LSMAOE () {0x20000000;}' unless defined(&SCTLR_LSMAOE);
    eval 'sub SCTLR_EnIB () {0x40000000;}' unless defined(&SCTLR_EnIB);
    eval 'sub SCTLR_EnIA () {0x80000000;}' unless defined(&SCTLR_EnIA);
    eval 'sub PSR_M_EL0t () {0x;}' unless defined(&PSR_M_EL0t);
    eval 'sub PSR_M_EL1t () {0x4;}' unless defined(&PSR_M_EL1t);
    eval 'sub PSR_M_EL1h () {0x5;}' unless defined(&PSR_M_EL1h);
    eval 'sub PSR_M_EL2t () {0x8;}' unless defined(&PSR_M_EL2t);
    eval 'sub PSR_M_EL2h () {0x9;}' unless defined(&PSR_M_EL2h);
    eval 'sub PSR_M_MASK () {0xf;}' unless defined(&PSR_M_MASK);
    eval 'sub PSR_AARCH32 () {0x10;}' unless defined(&PSR_AARCH32);
    eval 'sub PSR_F () {0x40;}' unless defined(&PSR_F);
    eval 'sub PSR_I () {0x80;}' unless defined(&PSR_I);
    eval 'sub PSR_A () {0x100;}' unless defined(&PSR_A);
    eval 'sub PSR_D () {0x200;}' unless defined(&PSR_D);
    eval 'sub PSR_IL () {0x100000;}' unless defined(&PSR_IL);
    eval 'sub PSR_SS () {0x200000;}' unless defined(&PSR_SS);
    eval 'sub PSR_V () {0x10000000;}' unless defined(&PSR_V);
    eval 'sub PSR_C () {0x20000000;}' unless defined(&PSR_C);
    eval 'sub PSR_Z () {0x40000000;}' unless defined(&PSR_Z);
    eval 'sub PSR_N () {0x80000000;}' unless defined(&PSR_N);
    eval 'sub PSR_FLAGS () {0xf0000000;}' unless defined(&PSR_FLAGS);
    eval 'sub TCR_ASID_16 () {(1<< 36);}' unless defined(&TCR_ASID_16);
    eval 'sub TCR_IPS_SHIFT () {32;}' unless defined(&TCR_IPS_SHIFT);
    eval 'sub TCR_IPS_32BIT () {(0<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_32BIT);
    eval 'sub TCR_IPS_36BIT () {(1<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_36BIT);
    eval 'sub TCR_IPS_40BIT () {(2<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_40BIT);
    eval 'sub TCR_IPS_42BIT () {(3<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_42BIT);
    eval 'sub TCR_IPS_44BIT () {(4<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_44BIT);
    eval 'sub TCR_IPS_48BIT () {(5<<  &TCR_IPS_SHIFT);}' unless defined(&TCR_IPS_48BIT);
    eval 'sub TCR_TG1_SHIFT () {30;}' unless defined(&TCR_TG1_SHIFT);
    eval 'sub TCR_TG1_16K () {(1<<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_16K);
    eval 'sub TCR_TG1_4K () {(2<<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_4K);
    eval 'sub TCR_TG1_64K () {(3<<  &TCR_TG1_SHIFT);}' unless defined(&TCR_TG1_64K);
    eval 'sub TCR_SH1_SHIFT () {28;}' unless defined(&TCR_SH1_SHIFT);
    eval 'sub TCR_SH1_IS () {(0x3 <<  &TCR_SH1_SHIFT);}' unless defined(&TCR_SH1_IS);
    eval 'sub TCR_ORGN1_SHIFT () {26;}' unless defined(&TCR_ORGN1_SHIFT);
    eval 'sub TCR_ORGN1_WBWA () {(0x1 <<  &TCR_ORGN1_SHIFT);}' unless defined(&TCR_ORGN1_WBWA);
    eval 'sub TCR_IRGN1_SHIFT () {24;}' unless defined(&TCR_IRGN1_SHIFT);
    eval 'sub TCR_IRGN1_WBWA () {(0x1 <<  &TCR_IRGN1_SHIFT);}' unless defined(&TCR_IRGN1_WBWA);
    eval 'sub TCR_SH0_SHIFT () {12;}' unless defined(&TCR_SH0_SHIFT);
    eval 'sub TCR_SH0_IS () {(0x3 <<  &TCR_SH0_SHIFT);}' unless defined(&TCR_SH0_IS);
    eval 'sub TCR_ORGN0_SHIFT () {10;}' unless defined(&TCR_ORGN0_SHIFT);
    eval 'sub TCR_ORGN0_WBWA () {(0x1 <<  &TCR_ORGN0_SHIFT);}' unless defined(&TCR_ORGN0_WBWA);
    eval 'sub TCR_IRGN0_SHIFT () {8;}' unless defined(&TCR_IRGN0_SHIFT);
    eval 'sub TCR_IRGN0_WBWA () {(0x1 <<  &TCR_IRGN0_SHIFT);}' unless defined(&TCR_IRGN0_WBWA);
    eval 'sub TCR_CACHE_ATTRS () {(( &TCR_IRGN0_WBWA |  &TCR_IRGN1_WBWA) | ( &TCR_ORGN0_WBWA |  &TCR_ORGN1_WBWA));}' unless defined(&TCR_CACHE_ATTRS);
    if(defined(&SMP)) {
	eval 'sub TCR_SMP_ATTRS () {( &TCR_SH0_IS |  &TCR_SH1_IS);}' unless defined(&TCR_SMP_ATTRS);
    } else {
	eval 'sub TCR_SMP_ATTRS () {0;}' unless defined(&TCR_SMP_ATTRS);
    }
    eval 'sub TCR_T1SZ_SHIFT () {16;}' unless defined(&TCR_T1SZ_SHIFT);
    eval 'sub TCR_T0SZ_SHIFT () {0;}' unless defined(&TCR_T0SZ_SHIFT);
    eval 'sub TCR_T1SZ {
        my($x) = @_;
	    eval q((($x) <<  &TCR_T1SZ_SHIFT));
    }' unless defined(&TCR_T1SZ);
    eval 'sub TCR_T0SZ {
        my($x) = @_;
	    eval q((($x) <<  &TCR_T0SZ_SHIFT));
    }' unless defined(&TCR_T0SZ);
    eval 'sub TCR_TxSZ {
        my($x) = @_;
	    eval q(( &TCR_T1SZ($x) |  &TCR_T0SZ($x)));
    }' unless defined(&TCR_TxSZ);
    eval 'sub DBG_SPSR_SS () {(0x1 << 21);}' unless defined(&DBG_SPSR_SS);
    eval 'sub DBG_MDSCR_SS () {(0x1 << 0);}' unless defined(&DBG_MDSCR_SS);
    eval 'sub DBG_MDSCR_KDE () {(0x1 << 13);}' unless defined(&DBG_MDSCR_KDE);
    eval 'sub DBG_MDSCR_MDE () {(0x1 << 15);}' unless defined(&DBG_MDSCR_MDE);
    eval 'sub PMCR_E () {(1<< 0);}' unless defined(&PMCR_E);
    eval 'sub PMCR_P () {(1<< 1);}' unless defined(&PMCR_P);
    eval 'sub PMCR_C () {(1<< 2);}' unless defined(&PMCR_C);
    eval 'sub PMCR_D () {(1<< 3);}' unless defined(&PMCR_D);
    eval 'sub PMCR_X () {(1<< 4);}' unless defined(&PMCR_X);
    eval 'sub PMCR_DP () {(1<< 5);}' unless defined(&PMCR_DP);
    eval 'sub PMCR_LC () {(1<< 6);}' unless defined(&PMCR_LC);
    eval 'sub PMCR_IMP_SHIFT () {24;}' unless defined(&PMCR_IMP_SHIFT);
    eval 'sub PMCR_IMP_MASK () {(0xff <<  &PMCR_IMP_SHIFT);}' unless defined(&PMCR_IMP_MASK);
    eval 'sub PMCR_IDCODE_SHIFT () {16;}' unless defined(&PMCR_IDCODE_SHIFT);
    eval 'sub PMCR_IDCODE_MASK () {(0xff <<  &PMCR_IDCODE_SHIFT);}' unless defined(&PMCR_IDCODE_MASK);
    eval 'sub PMCR_IDCODE_CORTEX_A57 () {0x1;}' unless defined(&PMCR_IDCODE_CORTEX_A57);
    eval 'sub PMCR_IDCODE_CORTEX_A72 () {0x2;}' unless defined(&PMCR_IDCODE_CORTEX_A72);
    eval 'sub PMCR_IDCODE_CORTEX_A53 () {0x3;}' unless defined(&PMCR_IDCODE_CORTEX_A53);
    eval 'sub PMCR_N_SHIFT () {11;}' unless defined(&PMCR_N_SHIFT);
    eval 'sub PMCR_N_MASK () {(0x1f <<  &PMCR_N_SHIFT);}' unless defined(&PMCR_N_MASK);
}
1;
