require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_COUNTER_H_)) {
    eval 'sub _MACHINE_COUNTER_H_ () {1;}' unless defined(&_MACHINE_COUNTER_H_);
    require 'sys/pcpu.ph';
    require 'machine/atomic.ph';
    eval 'sub EARLY_COUNTER () {& ($__pcpu[0]->{pc_early_dummy_counter});}' unless defined(&EARLY_COUNTER);
    eval 'sub counter_enter () {
        eval q( &do {}  &while (0));
    }' unless defined(&counter_enter);
    eval 'sub counter_exit () {
        eval q( &do {}  &while (0));
    }' unless defined(&counter_exit);
    if(defined(&IN_SUBR_COUNTER_C)) {
	eval 'sub counter_u64_read_one {
	    my($p,$cpu) = @_;
    	    eval q({ (*( &uint64_t *)($p +  &UMA_PCPU_ALLOC_SIZE * $cpu)); });
	}' unless defined(&counter_u64_read_one);
	eval 'sub counter_u64_fetch_inline {
	    my($p) = @_;
    	    eval q({  &uint64_t  &r; \'int\'  &i;  &r = 0;  &CPU_FOREACH( &i)  &r +=  &counter_u64_read_one(( &uint64_t *)$p,  &i); ( &r); });
	}' unless defined(&counter_u64_fetch_inline);
	eval 'sub counter_u64_zero_inline {
	    my($c) = @_;
    	    eval q({  &smp_rendezvous( &smp_no_rendezvous_barrier,  &counter_u64_zero_one_cpu,  &smp_no_rendezvous_barrier, $c); });
	}' unless defined(&counter_u64_zero_inline);
    }
    eval 'sub counter_u64_add_protected {
        my($c, $inc) = @_;
	    eval q( &counter_u64_add($c, $inc));
    }' unless defined(&counter_u64_add_protected);
    eval 'sub counter_u64_add {
        my($c,$inc) = @_;
	    eval q({  &atomic_add_64(( &uint64_t *) &zpcpu_get($c), $inc); });
    }' unless defined(&counter_u64_add);
}
1;
