require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_DB_MACHDEP_H_)) {
    eval 'sub _MACHINE_DB_MACHDEP_H_ () {1;}' unless defined(&_MACHINE_DB_MACHDEP_H_);
    require 'machine/armreg.ph';
    require 'machine/frame.ph';
    require 'machine/trap.ph';
    eval 'sub T_BREAKPOINT () {( &EXCP_BRK);}' unless defined(&T_BREAKPOINT);
    eval 'sub T_WATCHPOINT () {( &EXCP_WATCHPT_EL1);}' unless defined(&T_WATCHPOINT);
    eval 'sub PC_REGS () {
        eval q((( &db_addr_t) ($kdb_thrctx->{pcb_lr})));
    }' unless defined(&PC_REGS);
    eval 'sub BKPT_INST () {(0xd4200000);}' unless defined(&BKPT_INST);
    eval 'sub BKPT_SIZE () {(4);}' unless defined(&BKPT_SIZE);
    eval 'sub BKPT_SET {
        my($inst) = @_;
	    eval q(( &BKPT_INST));
    }' unless defined(&BKPT_SET);
    eval 'sub BKPT_SKIP () { &do {  ($kdb_frame->{tf_elr}) +=  &BKPT_SIZE; }  &while (0);}' unless defined(&BKPT_SKIP);
    eval 'sub db_clear_single_step () { &kdb_cpu_clear_singlestep;}' unless defined(&db_clear_single_step);
    eval 'sub db_set_single_step () { &kdb_cpu_set_singlestep;}' unless defined(&db_set_single_step);
    eval 'sub IS_BREAKPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &T_BREAKPOINT));
    }' unless defined(&IS_BREAKPOINT_TRAP);
    eval 'sub IS_WATCHPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &T_WATCHPOINT));
    }' unless defined(&IS_WATCHPOINT_TRAP);
    eval 'sub inst_trap_return {
        my($ins) = @_;
	    eval q((0));
    }' unless defined(&inst_trap_return);
    eval 'sub inst_return {
        my($ins) = @_;
	    eval q(((($ins) & 0xfffffc1f) == 0xd65f0000));
    }' unless defined(&inst_return);
    eval 'sub inst_call {
        my($ins) = @_;
	    eval q(((($ins) & 0xfc000000) == 0x94000000 || (($ins) & 0xfffffc1f) == 0xd63f0000));
    }' unless defined(&inst_call);
    eval 'sub inst_load {
        my($ins) = @_;
	    eval q(({  &uint32_t  &tmp_instr =  &db_get_value( &PC_REGS(), $sizeof{ &uint32_t},  &FALSE);  &is_load_instr( &tmp_instr); }));
    }' unless defined(&inst_load);
    eval 'sub inst_store {
        my($ins) = @_;
	    eval q(({  &uint32_t  &tmp_instr =  &db_get_value( &PC_REGS(), $sizeof{ &uint32_t},  &FALSE);  &is_store_instr( &tmp_instr); }));
    }' unless defined(&inst_store);
    eval 'sub is_load_instr {
        my($ins) = @_;
	    eval q((((($ins) & 0x3b000000) == 0x18000000) || ((($ins) & 0x3f400000) == 0x8400000) || ((($ins) & 0x3bc00000) == 0x28400000) || (((($ins) & 0x3b200c00) == 0x38000400)  && ((($ins) & 0x3be00c00) != 0x38000400)  && ((($ins) & 0xffe00c00) != 0x3c800400)) || (((($ins) & 0x3b200c00) == 0x38000c00)  && ((($ins) & 0x3be00c00) != 0x38000c00)  && ((($ins) & 0xffe00c00) != 0x3c800c00)) || (((($ins) & 0x3b200c00) == 0x38200800)  && ((($ins) & 0x3be00c00) != 0x38200800)  && ((($ins) & 0xffe00c00) != 0x3ca00c80)) || (((($ins) & 0x3b200c00) == 0x38000800)  && ((($ins) & 0x3be00c00) != 0x38000800)) || (((($ins) & 0x3b200c00) == 0x38000000)  && ((($ins) & 0x3be00c00) != 0x38000000)  && ((($ins) & 0xffe00c00) != 0x3c800000)) || (((($ins) & 0x3b000000) == 0x39000000)  && ((($ins) & 0x3bc00000) != 0x39000000)  && ((($ins) & 0xffc00000) != 0x3d800000))  && ((($ins) & 0x3bc00000) == 0x28400000) || ((($ins) & 0x3bc00000) == 0x28c00000) || ((($ins) & 0x3bc00000) == 0x29800000)));
    }' unless defined(&is_load_instr);
    eval 'sub is_store_instr {
        my($ins) = @_;
	    eval q((((($ins) & 0x3f400000) == 0x8000000) || ((($ins) & 0x3bc00000) == 0x28000000) || (((($ins) & 0x3be00c00) == 0x38000400) || ((($ins) & 0xffe00c00) == 0x3c800400)) || (((($ins) & 0x3be00c00) == 0x38000c00) || ((($ins) & 0xffe00c00) == 0x3c800c00)) || (((($ins) & 0x3be00c00) == 0x38200800) || ((($ins) & 0xffe00c00) == 0x3ca00800)) || ((($ins) & 0x3be00c00) == 0x38000800) || (((($ins) & 0x3be00c00) == 0x38000000) || ((($ins) & 0xffe00c00) == 0x3c800000)) || (((($ins) & 0x3bc00000) == 0x39000000) || ((($ins) & 0xffc00000) == 0x3d800000)) || ((($ins) & 0x3bc00000) == 0x28000000) || ((($ins) & 0x3bc00000) == 0x28800000) || ((($ins) & 0x3bc00000) == 0x29800000)));
    }' unless defined(&is_store_instr);
    eval 'sub next_instr_address {
        my($pc, $bd) = @_;
	    eval q((($bd) ? ($pc) : (($pc) + 4)));
    }' unless defined(&next_instr_address);
    eval 'sub DB_ELFSIZE () {64;}' unless defined(&DB_ELFSIZE);
}
1;
