require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PARAM_H_)) {
    eval 'sub _MACHINE_PARAM_H_ () {1;}' unless defined(&_MACHINE_PARAM_H_);
    require 'machine/_align.ph';
    eval 'sub STACKALIGNBYTES () {(16- 1);}' unless defined(&STACKALIGNBYTES);
    eval 'sub STACKALIGN {
        my($p) = @_;
	    eval q((( &uint64_t)($p) & ~ &STACKALIGNBYTES));
    }' unless defined(&STACKALIGN);
    eval 'sub __PCI_REROUTE_INTERRUPT () {1;}' unless defined(&__PCI_REROUTE_INTERRUPT);
    unless(defined(&MACHINE)) {
	eval 'sub MACHINE () {"arm64";}' unless defined(&MACHINE);
    }
    unless(defined(&MACHINE_ARCH)) {
	eval 'sub MACHINE_ARCH () {"aarch64";}' unless defined(&MACHINE_ARCH);
    }
    unless(defined(&MACHINE_ARCH32)) {
	eval 'sub MACHINE_ARCH32 () {"armv7";}' unless defined(&MACHINE_ARCH32);
    }
    if(defined(&SMP) || defined(&KLD_MODULE)) {
	unless(defined(&MAXCPU)) {
	    eval 'sub MAXCPU () {256;}' unless defined(&MAXCPU);
	}
    } else {
	eval 'sub MAXCPU () {1;}' unless defined(&MAXCPU);
    }
    unless(defined(&MAXMEMDOM)) {
	eval 'sub MAXMEMDOM () {2;}' unless defined(&MAXMEMDOM);
    }
    eval 'sub ALIGNBYTES () { &_ALIGNBYTES;}' unless defined(&ALIGNBYTES);
    eval 'sub ALIGN {
        my($p) = @_;
	    eval q( &_ALIGN($p));
    }' unless defined(&ALIGN);
    eval 'sub ALIGNED_POINTER {
        my($p, $t) = @_;
	    eval q((((($p)) & ($sizeof{$t} - 1)) == 0));
    }' unless defined(&ALIGNED_POINTER);
    eval 'sub CACHE_LINE_SHIFT () {7;}' unless defined(&CACHE_LINE_SHIFT);
    eval 'sub CACHE_LINE_SIZE () {(1<<  &CACHE_LINE_SHIFT);}' unless defined(&CACHE_LINE_SIZE);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {( &PAGE_SIZE - 1);}' unless defined(&PAGE_MASK);
    eval 'sub PAGE_SHIFT_16K () {14;}' unless defined(&PAGE_SHIFT_16K);
    eval 'sub PAGE_SIZE_16K () {(1<<  &PAGE_SHIFT_16K);}' unless defined(&PAGE_SIZE_16K);
    eval 'sub PAGE_MASK_16K () {( &PAGE_SIZE_16K - 1);}' unless defined(&PAGE_MASK_16K);
    eval 'sub PAGE_SHIFT_64K () {16;}' unless defined(&PAGE_SHIFT_64K);
    eval 'sub PAGE_SIZE_64K () {(1<<  &PAGE_SHIFT_64K);}' unless defined(&PAGE_SIZE_64K);
    eval 'sub PAGE_MASK_64K () {( &PAGE_SIZE_64K - 1);}' unless defined(&PAGE_MASK_64K);
    eval 'sub MAXPAGESIZES () {2;}' unless defined(&MAXPAGESIZES);
    unless(defined(&KSTACK_PAGES)) {
	eval 'sub KSTACK_PAGES () {4;}' unless defined(&KSTACK_PAGES);
    }
    eval 'sub KSTACK_GUARD_PAGES () {1;}' unless defined(&KSTACK_GUARD_PAGES);
    eval 'sub PCPU_PAGES () {1;}' unless defined(&PCPU_PAGES);
    unless(defined(&VM_BCACHE_SIZE_MAX)) {
	eval 'sub VM_BCACHE_SIZE_MAX () {(400* 1024* 1024);}' unless defined(&VM_BCACHE_SIZE_MAX);
    }
    eval 'sub round_page {
        my($x) = @_;
	    eval q(((($x) +  &PAGE_MASK) & ~ &PAGE_MASK));
    }' unless defined(&round_page);
    eval 'sub trunc_page {
        my($x) = @_;
	    eval q((($x) & ~ &PAGE_MASK));
    }' unless defined(&trunc_page);
    eval 'sub atop {
        my($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&atop);
    eval 'sub ptoa {
        my($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&ptoa);
    eval 'sub arm64_btop {
        my($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&arm64_btop);
    eval 'sub arm64_ptob {
        my($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&arm64_ptob);
    eval 'sub pgtok {
        my($x) = @_;
	    eval q((($x) * ( &PAGE_SIZE / 1024)));
    }' unless defined(&pgtok);
}
1;
